<?php
/**
 * Implement hook_rules_action_info().
 */
 
function send_sms_rules_action_info() {
    
	$actions = array(
    'send_sms_rules_action_send_sms' => array(
	  'label'=> t('Send SMS'),
	  'group' => t('Send SMS'),
	  'parameter' => array(
		'thebody' => array(
		  'type' => 'text',
		  'label' => t('The SMS message')
		),
		'thesender' => array(
		  'type' => 'text',
		  'label' => t('The SMS Sender')
		),
		'thenumber' => array(
		  'type' => 'text',
		  'label' => t('The SMS Phone number')
		)
	  )
	)
	
  );
  
  return $actions; 
  
}

// The callback to send the SMS
function send_sms_rules_action_send_sms($thebody, $thesender, $thenumber) {
	
	//get the variables stored in the settings form 
	$theusername = variable_get('theusername', '');
	$sms_username_label = variable_get('sms_username_label', '');
	$thepassword = variable_get('thepassword', '');
	$sms_password_label = variable_get('sms_password_label', '');
	$sms_message_label = variable_get('sms_message_label', '');
	$sms_sender_label = variable_get('sms_sender_label', '');
	$sms_recipient_label = variable_get('sms_recipient_label', '');
	$show_info = variable_get('show_info', '');
	$sms_base_url = variable_get('sms_base_url', '');
	
	//encode the text field for the message 
	//$themessage = rawurlencode($thebody);
	$themessage = $thebody;
	
	//use http_build_query
	$parameters = array(
      $sms_username_label => $theusername,
      $sms_password_label => $thepassword,
      $sms_message_label => $themessage,
      $sms_sender_label => $thesender,
      $sms_recipient_label => $thenumber
    );
	
	$url_params = http_build_query($parameters);
	$url = $sms_base_url. "?".$url_params;
	
	// use drupal drupal_http_request to send a post request to the API.
	
	$create_message = drupal_http_request(
	  $url, array(
	    'headers' => array('Content-Type' => 'application/json'),
	    'method' => 'POST'
	  ));
	  
	if($show_info == 1){
		drupal_set_message($create_message->data);
	}

//dpm($theusername);
//dpm($list_item);
}